#define _XOPEN_SOURCE
#include <locale.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>

#define UPPER_BOUND 49
#define SAMPLE_SIZE 6
#define SAMPLE_COUNT 8
#define RANDINT(x) (int)((double) rand() / ((double) RAND_MAX + 1) * (x) + 1)

int matches(int *set1, int *set2)
{
	int i, j, count;
	count = 0;
	j = 0;
	for (i = 0; i < SAMPLE_SIZE; i++) {
		while (set1[i] > set2[j] && j < SAMPLE_SIZE - 1) j++;
		if (j >= SAMPLE_SIZE - 1 && set1[i] > set2[j]) break;
		if (set1[i] == set2[j]) count++;
	}
	return count;
}
void mybet(int *output)
{
	char bitfield[UPPER_BOUND];
	int i, j, pos;
	memset(bitfield, 0, sizeof(bitfield));
	for (i = 0; i < SAMPLE_SIZE; i++) {
		pos = -1;
		j = RANDINT(UPPER_BOUND - i);
		while (j) {
			pos++;
			if (!bitfield[pos]) j--;
		}
		bitfield[pos] = 1;
	}
	pos = 0;
	for (i = 0; i < UPPER_BOUND; i++) {
		if (bitfield[i]) output[pos++] = i + 1;
	}
}

int main(void)
{
	char datestr[11];
	char decformat[9];
	char fullday[20];
	struct tm date;
	time_t midnighttime;
	int lotto[SAMPLE_SIZE];
	int mylotto[SAMPLE_SIZE];
	FILE *f;
	int i, curmatches, maxmatches, maxmatchcount;

	memset(datestr, 0, sizeof(datestr));
	memset(&date, 0, sizeof(struct tm));
	setlocale(LC_TIME, "");

	if ((f = fopen("lotto.txt", "r"))) {
		while (!feof(f)) {
			fscanf(f, "%*d\t%10c", datestr);
			strcpy(decformat, "\t%d");
			for (i = 0; i < SAMPLE_SIZE; i++) {
				/* Zusatzzahl interessiert nicht */
				if (i >= SAMPLE_SIZE - 1) strcat(decformat, "\t%*d\n");
				fscanf(f, decformat, lotto + i);
			}

			strptime(datestr, "%d.%m.%Y", &date);
			strftime(fullday, sizeof(fullday), "%a %x", &date);
			midnighttime = mktime(&date);
			srand((unsigned int) midnighttime);
			maxmatches = 0;
			maxmatchcount = 0;
			for (i = 0; i < SAMPLE_COUNT; i++) {
				mybet(mylotto);
				curmatches = matches(lotto, mylotto);
				if (curmatches > maxmatches) {
					maxmatches = curmatches;
					maxmatchcount = 1;
				} else if (curmatches == maxmatches) {
					maxmatchcount++;
				}
			}
			printf("%s: %d Richtige", fullday, maxmatches);
			if (maxmatches > 0 && maxmatchcount > 1) {
				printf(" (%d Mal)\n", maxmatchcount);
			} else {
				puts("");
			}
		}
		fclose(f);
	}
	return EXIT_SUCCESS;
}
